#
# Licensed Materials - Property of IBM
# (c) Copyright IBM Corporation 2008. All Rights Reserved. 
#
# Note to U.S. Government Users Restricted Rights:  Use, duplication or
# disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
#

use strict;
use CQPerlExt;

my $numArgs = @ARGV;

if ($numArgs != 14) {
   print STDERR ("Error: Incorrect Number of Arguments\n");
   print STDERR ("Usage: ratlperl PerformCQAction -username <user> -password <password> -userdb <user db> -dbset <dbset> -type <RecordType> -id <RecordID> -action <Action>\n");
   exit(1);
}	

if ($ARGV[9] eq "UCMUtilityActivity") {

   my $CQSession = CQSession::Build();

   $CQSession->UserLogon($ARGV[1], $ARGV[3], $ARGV[5], $ARGV[7]);

   my $EntityObj = $CQSession->GetEntity($ARGV[9], $ARGV[11]);
   
   my $CurrentState = $EntityObj->GetFieldValue("State")->GetValue();
   
   if ($CurrentState eq "Active") {
    
      $EntityObj->EditEntity("$ARGV[13]");
      my $Status = $EntityObj->Validate();
    
      if ($Status == "") {
         $Status = $EntityObj->Commit();
         
         if ($Status != "") {
            print STDERR ("Error: Unable to commit entity\n");
            exit(1);
         }
      } else {
         print STDERR ("Error: Unable to validate entity\n");
         exit(1);
      }
   }
} else {
   print STDERR ("Error: Unsupported Record Type: $ARGV[9]\n");
   exit(1);
}